# Security Policy

## Reporting a Vulnerability


Please report (suspected) security vulnerabilities to marcinguy@gmail.com. You will receive a response from us within 48 hours. If the issue is confirmed, we will release a patch as soon as possible depending on complexity, but historically within a few days.

Using the gpg

```
Key ID
    E8958CBEF5CD8AC6
PGP Fingerprint
    CF7D CDAE D1F7 E8B3 1990 91E8 E895 8CBE F5CD 8AC6
    

-----BEGIN PGP PUBLIC KEY BLOCK-----
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=kKHj

-----END PGP PUBLIC KEY BLOCK-----
```
